//#include "mattsparse.hh"
#include "mattdense.hh"
#include "vectdense.hh"

int main() {

  int nr=25;
  int nc=25;

  // fill in sparse matrix
  //  MatTSparse<float> m(nr,nc);
  MatTDense<float> m(nr,nc);
  for (int i=0;i<nr; i++) {
    for (int j=0;j<nc; j++) {
      if (i==j) m(i,j)=4.0f;
      if (abs(i-j)==1) m(i,j)=-1.0f;
      if (abs(i-j)==5) m(i,j)=-1.0f;
    }
  }

  // print it out
  cout<<"CRS TEST"<<endl<<endl;
  //m.matPrint(cout);
  m.report(cout);
  cout<<endl;

  // create input vector
  VecTDense<float> in(nr);
  for (int i=0;i<nr;i++) in(i)=1.0;

  // create output vector
  VecTDense<float> out(nr);
  for (int i=0;i<nr;i++) out(i)=0.0;

  // multiply
  m.matmult(in,out);

  cout<<"INPUT VECTOR:\n";
  in.report(cout);
  cout<<endl;

  cout<<"OUTPUT VECTOR:\n";
  out.report(cout);
}
