#include "cs.h"

int main() {

  int nr=4;
  int nc=4;
  int nnz=6;

  int ja[6];
  int ia[5];
  float data[6];
  float x[4];
  float b[4];

  CRSINFO a;
  CRS m;

  FILE * fp;

  a.nc=nc;
  a.nr=nr;
  a.nnz=nnz;
  a.inrows=(char *)malloc(128*sizeof(char));
  a.incols=(char *)malloc(128*sizeof(char));
  a.indata=(char *)malloc(128*sizeof(char));
  strcpy(a.inrows,"iatest");
  strcpy(a.incols,"jatest");
  strcpy(a.indata,"atest");

  fp=fopen("crsinfotest","w");
  crsInfoWrite(a,fp);
  fclose(fp);

  ja[0]=0;
  ja[1]=1;
  ja[2]=0;
  ja[3]=3;
  ja[4]=2;
  ja[5]=1;

  ia[0]=0;
  ia[1]=2;
  ia[2]=3;
  ia[3]=5;
  ia[4]=6;

  data[0]=3.1;
  data[1]=4.1;
  data[2]=5.9;
  data[3]=2.7;
  data[4]=-6.5;
  data[5]=-8.2;

  fp=fopen("jatest","w");
  fwrite(ja,sizeof(int),nnz,fp);
  fclose(fp);
  
  fp=fopen("iatest","w");
  fwrite(ia,sizeof(int),nr,fp);
  fclose(fp);
  
  fp=fopen("atest","w");
  fwrite(data,sizeof(float),nnz,fp);
  fclose(fp);

  crsInfoConstruct(&a);
  fp=fopen("crsinfotest","r");
  crsInfoRead(&a,fp);
  fclose(fp);

  printf("*** CRSINFO struct from file crsinfotest ***\n\n");
  crsInfoWrite(a,stdout);
  printf("\n");

  crsConstruct(&m);
  crsRead(&m,a);

  crsPrint(m,stdout);

  printf("\n *** as matrix ***\n\n");
  crsMatPrint(m,stdout);

  
  x[0]=1.0f; b[0]=0.0f;
  x[1]=1.0f; b[1]=0.0f;
  x[2]=1.0f; b[2]=0.0f;
  x[3]=1.0f; b[3]=0.0f;


  crsMatVec(m,x,b);
  printf("\nProduct of sparse matrix with vector of 1's:\n");
  printf("%14.6e\n",b[0]);
  printf("%14.6e\n",b[1]);
  printf("%14.6e\n",b[2]);
  printf("%14.6e\n",b[3]);
  
  
}

