#include "deriv.hh"

void Deriv1D::matmult(VecPPBase const & vecin,
		 VecPPBase & vecout) const {

  
  Grid1D const * gin = NULL;
  gin = dynamic_cast<Grid1D const *>(&vecin);
  if (!gin) {
    cerr<<"Error: Deriv1D::matmult\n";
    cerr<<"input vector not VecPPGridFile\n";
    exit(1);
  }

  // should check the grids are properly related here
  // not just the lengths
  if (vecin.getLength() != vecout.getLength()+1) {
    cerr<<"Error: Deriv1D::matmult\n";
    cerr<<"output vector length != input vector length - 1\n";
    exit(1);
  }    

  // the one place where we have to use the grid nature of the input
  double dx = gin->getStep();
  if ( dx <= 0.0) {
    cerr<<"Error: Deriv1D::matmult\n";
    cerr<<"dx = "<<dx<<" too small\n";
    exit(1);
  }        

  dx=1.0/dx; // division is expensive!!!
  int n=vecin.getLength();
  for (int i=0;i<n-1;i++) vecout(i)=(vecin(i+1)-vecin(i))*dx;

}
