#include <stdio.h>

/*
Author: WWS 

Purpose: explores the influence of scope (program block definition,
via braces) on variable declaration.
*/

int main() {

  printf("Expl 11: exploring scope\n");

  /* start a new scope internal to the main program block */
  {
    /* declar a variable inside it - note that this is permissible,
       AT THE BEGINNING OF THE SCOPE! (even though other statements
       precede the declaration in the enclosing scope)
    */
    float f = 2.0f/3.0f;
    /* print inside */ 
    printf("2/3 in single precision = %20.15e\n",f);
  }

  /* attempt to print outside */
  printf("2/3 in single precision = %20.15e\n",f);

  return 0;

}
