#include <stdio.h>

/*
Author: WWS

Purpose: illustrate accumulation via for loop, to approximate
an integral

Note the single-line scope convention for for (no {...})

Question: why is n treated as a float in the declaration/assignment
of d?
*/

int main() {

  float s = 0.0f;   /* sum (approx. integral), initialized to zero */
  int   n = 100;    /* number of quadrature intervals */
  float d = 1.0f/n; /* step (length of quad interval */
  int i;            /* loop counter */

  printf("approximate integral of x^2 from 0 to 1\n"); 

  for (i=0;i<n;i++) s+=d*(i*d)*(i*d);
  printf("  using %d quadrature points: ans = %e\n",n,s);

  s = 0.0f;
  n = n*10;
  d = 1.0f/n;
  for (i=0;i<n;i++) s+=d*(i*d)*(i*d);
  printf("  using %d quadrature points: ans = %e\n",n,s);

  s = 0.0f;
  n = n*10;
  d = 1.0f/n;
  for (i=0;i<n;i++) s+=d*(i*d)*(i*d);
  printf("  using %d quadrature points: ans = %e\n",n,s);
  return 0;

}
