/* 
   Author: WWS 
   Purpose: illustrate multidimensional array syntax in C
   by defining a matrix and multiplying a vector by it.
*/

#include <stdio.h>

int main() {

  const int ncols = 2; /* number of columns */
  const int nrows = 3; /* number of rows    */
  int i,j;             /* loop counters     */
  double a[nrows][ncols]; 
  double b[nrows];
  double x[ncols];

  /* assign matrix entries - loop over rows, cols */
  /* with loop scopes explicitly indicated by braces */
  /*
  for (i=0;i<nrows;i++) {
    for (j=0;j<ncols;j++) {
      a[i][j]=i+j;
    }
  }
  */
  /* single-line scope convention */
  for (i=0;i<nrows;i++) 
    for (j=0;j<ncols;j++) 
      a[i][j]=i+j;

  /* print matrix */

  for (i=0;i<nrows;i++) {
    for (j=0;j<ncols;j++) printf("a(%d,%d)=%12.4e ",i,j,a[i][j]);
    printf("\n");
  }
  printf("\n");

  /* define x (input vector), print */
  for (j=0;j<ncols;j++) {
    x[j]=j+1;
    printf("x(%d)=%12.4e\n",j,x[j]);
  }
  printf("\n");

  /* multiply x by a, store in b, print result */
  for (i=0;i<nrows;i++) {
    b[i]=0.0;
    for (j=0;j<ncols;j++) b[i]+=a[i][j]*x[j];
    printf("b(%d)=%12.4e\n",i,b[i]);
  }

  return 0;
}
