#include <stdio.h>

/*
Author: WWS 

Purpose: powers of 2 by function call, double version, using K&R's
power function (p. 27) Show how definition may appear after use,
provided declaration appears before. This one really is sensitive to
the absence of the declaration - if it's left off, the implicit return
type (int) doesn't match that of the function definition, so the code
will not compile.
*/

/* declaration of power function ahead of its use in main */
/* COMMON BUG - see what happens when declaration is omitted */


int main() {
  int n=11;
  int i;
  for (i=0;i<n;i++) printf("2^%4.2d = %12.4e\n",i,power(2.0,i));
}

/* power function - returns base^n */
double power(double base, int n) {
  double p;
  for (p=1.0; n>0; n--) p *= base;
  return p;
}

