/*
 * Author: WWS
 * illustrates one of the few differences between arrays and
 * pointers: an array is not a modifiable l-value, even though
 * the name of the array is an alias for its location - in effect,
 * the array addresses are constant. That is not true of pointers - 
 * they are variables, and can be modified by appearing in the lhs
 * of assignment statements - i.e. they are modifiable l-values.
 */

#include <stdio.h>

int main() {

  char a[10];
  char * b=a;
  char * c=&(a[2]);

  printf("a=%zu b=%zu c=%zu\n",a,b,c);

  b=c;
  printf("a=%zu b=%zu c=%zu\n",a,b,c);

  // this is - and must be - illegal!
  //  a=c;
}

