/*
 * Author: WWS
 * Purpose: the classic seg fault - writing off the end of an
 * array. Let's see what happens...
 *
 * Also illustrates a simple use of command line arguments to 
 * pass values to a program
 */

#include <stdio.h>

int main(int argc, char * argv[]) {

  int n;                  // max val of runaway index
  int i;                  // loop counter
  char s[10]="fruitcake"; // not enough for us!

  // we want to reference argv[1], so check that it's there...
  if (argc != 2) {
    printf("usage: ./a.out [int]\n");
    return 0;
  }

  // argv[0] is the name of the program, so argv[1] stores
  // the first argument

  printf("argv[0] = %s argv[1]= %s\n",argv[0],argv[1]);
  
  // but it's a string, even though it looks like an int -
  n=atoi(argv[1]);  // see p. 251 for atoi

  printf("assigning %d characters after %s\n",n,s);

  // make a really long string...
  s[9]=' ';
  for (i=0;i<n;i++) s[10+i]='z'; 
  s[10+n]='\0';

  printf("the result: %s\n",s);

  return 0;
}
