/*
 * Author: WWS
 * Purpose: van der Linden's arrays vs. pointers expl, modified
 * to show how pointer arritmetic and array indexing yield the
 * same result, even though - at the top - the array is not identical
 * to the pointer to its first address!
 *
 * References: Ch. 9 in van der Linden, Sect. 5.4 in K&R
 */

#include <stdio.h>

// in side a function, you can treat an array like a pointer...
void arr_fun(char a[]) {
  printf("addr of array param = %zu\n",&a);
  printf("addr of a[0]        = %zu\n",a);  
  printf("addr of a[1]        = %zu\n",a+1);
  printf("++a                 = %zu\n",++a);
  printf("a++                 = %zu\n",a++);
  printf("a                   = %zu\n",a);
}

// and treat pointers like arrays
void ptr_fun(char * p) {
  printf("addr of p           = %zu\n",&p);
  printf("addr of p[0]        = %zu\n",&(p[0]));  
  printf("addr of p[1]        = %zu\n",&(p[1]));
}

int main() {
  int i;
  char fish[10]="porpoise"; // I don't want to hear it
  printf("addr of fish in main= %zu\n",&fish);
  printf("addr of fish[0]     = %zu\n",&(fish[0]));  
  printf("addr of fish[1]     = %zu\n",&(fish[1]));
  printf("\npass fish as an array...\n\n");
  arr_fun(fish);
  printf("\npass fish as a pointer...\n\n");
  ptr_fun(fish);

  // *(fish+i) is the SAME as f[i]
  printf("all to what \n");
  for (i=0;i<10;i++) 
    printf("%c\n",*(fish+i));

  return 0;

}
