/*
 * Author: WWS
 *
 * Purpose: demonstrate use of 
 * - external library function B_zeroin to find roots
 * - formatted input funtion scanf 
 * - "include everything" header file cstd.h
 */

/* this header file includes every header file you
 * could ever want
 */
#include "cstd.h"

/* my hack of R's hack of zeroin */
double B_zeroin(double,double,double (*)(double),double *,int *);

/* a simple quadratic - roots 1, 2 */
double q1(double x) {
  return x*x-3.0*x+2.0;
}

int main() {

  /* declarations */
  double ax;   // left endpoint
  double bx;   // right endpoint
  double tol;  // tolerance for root (not function value!)
  int maxit;   // max number of zeroin iterations allowed
  double x;    // storage for root estimate

  // NOTE: *** pointer *** to target data passed to scanf!!! 
  // NOTE: *** strangely, reading a double requires format lf 
  //   (fixed point) or le (floating point) or lg (either)
  //   - unlike printf

  printf("**********************\n");
  printf("* Data Entry section  \n");
  printf("**********************\n\n");
  printf("enter initial lower estimate: ");
  scanf("%lg",&ax);
  printf("\nenter initial upper estimate: ");
  scanf("%lg",&bx);
  printf("\nenter desired tolerance: ");
  scanf("%lg",&tol);
  printf("\nenter max permitted iterations: ");
  scanf("%d",&maxit);
  printf("\n\n");

  printf("***************************\n");
  printf("* Roots by Brent's Method  \n");
  printf("***************************\n\n");  

  printf("initial lower estimate=%g\n",ax);
  printf("initial upper estimate=%g\n",bx);
  printf("initial tolerance=%g\n",tol);
  printf("max iterations allowed=%d\n",maxit);

  x=B_zeroin(ax,bx,q1,&tol,&maxit);

  printf("estimated root=%20.14e\n",x);
  printf("iterations used=%d\n",maxit);
  printf("final tolerance=%20.14e\n",tol);
  printf("value at estimated root=%20.14e\n",q1(x));
}
