/* 
 * Author: WWS
 *
 * Purpose: illustrate stack overflow - most systems have
 * strict limit to the size of the stack, which includes
 * the region in which automatic variable memory 
 * resides. 
 */

// length of a really long array
#define N 1600000
// comment this out to see stack overflow
//#define DYN

#include <stdio.h>
#ifdef DYN
#include <stdlib.h>
#endif

int main() {
  int i;

  // the scanf "pause" trick
  scanf("%d",&i);

  // dynamic allocation...
#ifdef DYN
  double * x = (double *)malloc(N*sizeof(double));
#else
  // vs static allocation of the same workspace
  double x[N];
#endif
  // now try to access
  for (i=0;i<N;i++) x[i]=0.0;
}
