/*
 * Author: WWS
 *
 * Purpose: extremely simple run-around-the-block for
 * very simple array storage class - after ex40.c
 *
 */

#include "vecpp.hh"

int main(int argc, char ** argv) {

  // for the nth time - note no need to declare counters at the
  // top, or anywhere outside of loop bodies
  int n=10;            // vector size

  // create a VecPP - note, default constructor has no argument
  // no need to give any, so this looks like a declaration - but
  // it also initializes the private data members.
  VecPP v;

  // now, the one-time post-construction initialization
  // which allocates array of len n
  v.init(n);    

  // now the length is an attribute of the VecPP object, so 
  // identify as such
  for (int i=0;i<v.size();i++)    // fill it with floats
    //    v.set(i,(double)i);
    v(i)=(double)i;

  // print it out on C++ version of stdout (like printf)
  v.write(cout);

  // some busts:

  // 1. out-of-bounds access, two ways
  // v.set(11,11.0);

  // 2. attempt at memory leak
  //  v.init(22);

  exit(0);
}
