#include "matdense.hh"
#include "vecppdense.hh"

void simplecg(MatBase const &,
	      VecPPBase const &,
	      VecPPBase &,
	      VecPPBase &,
	      VecPPBase &,
	      VecPPBase &,
	      int);

int main(int argc, char ** argv) {

  int dim = 4;
  
  // create matrix - must be symmetric positive definite
  MatDense A(dim,dim);
  
  A(0,0)=4.0;
  A(0,1)=-1.0;
  A(0,2)=0.0;
  A(0,3)=0.0;

  A(1,0)=-1.0;
  A(1,1)=4.0;
  A(1,2)=-1.0;
  A(1,3)=0.0;

  A(2,0)=0.0;
  A(2,1)=-1.0;
  A(2,2)=4.0;
  A(2,3)=-1.0;

  A(3,0)=0.0;
  A(3,1)=0.0;
  A(3,2)=-1.0;
  A(3,3)=4.0;

  A.report(cout);

  // create RHS
  VecPPDense b(dim);
  b(0)=3.0;
  b(1)=2.0;
  b(2)=2.0;
  b(3)=3.0;

  // create workspace
  VecPPDense r(dim);
  VecPPDense p(dim);
  VecPPDense ap(dim);

  // estimated solution
  VecPPDense x(dim);

  // two its of CG
  simplecg(A,b,x,r,p,ap,2);

  // what did we get
  x.report(cout);

}
