/*
 * Author: WWS
 * Purpose: illustrate a few properties of C++ standard strings
 */

#include "cppstd.hh"

int main() {

  // initialization using  a literal string constant
  string f = "fruitcake";

  // write to stream - note standard library end-of-line
  // struct
  cout<<f<<endl;
  
  // add another string
  string g = " cook";
  string h=f+g;
  cout<<h<<endl;

  // copy a string
  string k = g;
  cout<<k<<endl;

  // add a string literal
  h+="ed";
  cout<<h<<endl;

  // index into the string
  cout<<"char 6 = "<<h[6]<<endl;

  // print the size 
  cout<<"size of h = "<<h.size()<<endl;

  // extract the C string hiding inside the C++ string -
  // note that c_str() returns a const char *.
  printf("%s\n",h.c_str());

  // use some analogous C functions
  char * cs = new char[h.size()+1];
  strcpy(cs,h.c_str());
  printf("%s\n",cs);
  printf("size of h = %d\n",strlen(cs));

  // add another string using C string library
  char m[1000]; // surely enough
  strcpy(m,cs);
  strcat(m," to perfection");
  printf("%s\n",m);

}
