/*
 * Author: WWS
 *
 * Purpose: extremely simple run-around-the-block for
 * very simple templated array storage class - after ex40.c
 *
 */

#include "vectdense.hh"
#include "vectsparse.hh"

int main(int argc, char ** argv) {

  int n=10;            // vector size

  cout<<"create a VecT<float>\n"; 
  VecTDense<float> v(n);
  v.report(cout);

  cout<<"fill it with floats\n";
  for (int i=0;i<v.getLength();i++)    
    v(i)=(float)i;

  cout<<"Dense Vector Report:\n";
  v.report(cout);
  cout<<"\n";

  cout<<"instantiate VecTSparse<double object\n";
  VecTSparse<double> w(n);

  cout<<"assign element 5, uses non-const index op\n";
  w(5)=1.0;

  cout<<"Sparse Vector Report:\n";
  w.report(cout);

  cout<<"get element 6 = "<<w(6)<<" - also invokes non-const op(), since object was not declared const\n";

  cout<<"report again\n";

  w.report(cout);

  cout<<"declare const reference to w\n";
  VecTSparse<double> const & z = w;

  /*
  cout<<"attempt to assign, thus invoking non-const operator()\n";
  z(1)=2.0;
  */

  cout<<"access element of w through const reference - no change\n";
  cout<<"in w's storage\n";
  cout<<"w(7)="<<z(7)<<"\n";
  w.report(cout);

  // this does not work - discuss
  //  cout<<"dot product = "<<v.dot(w)<<" only invokes const op()\n";

  exit(0);
}
