#ifndef __CAAM420_GRID__
#define __CAAM420_GRID__

#include "cppstd.hh"

/*
 * Author: WWS
 * Purpose: Mix-in defining attributes of 1D (infinite) grid
 */

class Grid1D {

private:

  double o1;  // origin
  double d1;  // step

  Grid1D();

public: 

  Grid1D(double _o1, double _d1) {
    o1=_o1; d1=_d1;
  }

  double getOrigin() const { return o1; }
  double getStep() const { return d1; }

  virtual ostream & report(ostream & str) const {
    str<<"1D grid attributes: \n";
    str<<"  o1 = "<<this->o1<<"\n";
    str<<"  d1 = "<<this->d1<<"\n";
    return str;
  }
};

#endif
