/*
 * Author: WWS
 *
 * struct mat - declarations and macros
 *
 * Purpose: simple matrix struct and associated functions
 */

#ifndef __WWS_MAT__
#define __WWS_MAT__

/* use struct vec and its definitions
 */
#include "vec.h"

/* hard-coded limits */
#define MAXC 128 /* max line length */
#define MAXD 10000 /* max matrix size */
#define IN  1   /* inside a word */
#define OUT 0   /* outside a word */

/* simple matrix struct */
struct mat {
  int nrows;
  int ncols;
  double * mdata;
};

/* constructor - default */
void mat_construct(struct mat * );

/* post-construction initialization using nrows and ncols */
int mat_init(struct mat *, int, int);

/* post-construction initialization using file data - assumed
 * to be natural human-readable rectangular array of decimal
 * representations, either fixed- or floating-point.
 */
int mat_finit(struct mat *, FILE * fp);

/* destructor */
void mat_destroy(struct mat *);

/* print to terminal */
void mat_print(struct mat);

/* print to file */
void mat_print(struct mat, FILE *);

/* post-construction initialization of struct vec from file */
int vec_finit(struct vec *, FILE * fp);

#endif
