#include "matbase.hh"

void MatBase::matmult(VecPPBase const & vecin,
		      VecPPBase & vecout) const {

  if (vecin.getLength() != this->getNumCols()) {
    cerr<<"Error: MatBase::matmult\n";
    cerr<<"input vector length = "<<vecin.getLength()<<"\n";
    cerr<<"number of cols in this = "<<this->getNumCols()<<"\n";
    exit(1);
  }
  if (vecout.getLength() != this->getNumRows()) {
    cerr<<"Error: MatBase::matmult\n";
    cerr<<"output vector length = "<<vecout.getLength()<<"\n";
    cerr<<"number of rowss in this = "<<this->getNumRows()<<"\n";
    exit(1);
  }
  vecout.zero();
  for (int i=0;i<this->getNumRows(); i++) {
    for (int j=0;j<this->getNumCols();j++) {
      vecout(i)+=(*this)(i,j)*vecin(j);
    }
  }
}

ostream & MatBase::report(ostream & str) const {
  str<<"MatBase - matrix object\n";
  for (int i=0;i<this->getNumRows();i++) {
    for (int j=0;j<this->getNumCols();j++) {
      str<<setw(14)<<setprecision(6)<<setiosflags(ios::scientific)<<(*this)(i,j);
    }
    str<<"\n";
  }
  return str;
}
