#include "matdense.hh"

MatDense::MatDense(int n, int m): MatBase() {
  nrows=n;
  ncols=m;
  data=NULL;
  data=new double[nrows*ncols];
  if (!data) {
    cerr<<"Error: MatDense constructor\n";
    cerr<<"failed to allocate matrix memory\n";
    exit(1);
  }
}

double & MatDense::operator()(int i,int j) {
  if (i<0 || i>nrows-1) {
    cerr<<"Error: MatDense::operator() (non-const)\n";
    cerr<<"row index = "<<i<<" out of range [0,"<<nrows-1<<"]\n";
    exit(1);
  }
  if (j<0 || j>ncols-1) {
    cerr<<"Error: MatDense::operator() (non-const)\n";
    cerr<<"col index = "<<j<<" out of range [0,"<<ncols-1<<"]\n";
    exit(1);
  }
  return data[j+ncols*i];
}

double const & MatDense::operator()(int i,int j) const {
  if (i<0 || i>nrows-1) {
    cerr<<"Error: MatDense::operator() (non-const)\n";
    cerr<<"row index = "<<i<<" out of range [0,"<<nrows-1<<"]\n";
    exit(1);
  }
  if (j<0 || j>ncols-1) {
    cerr<<"Error: MatDense::operator() (non-const)\n";
    cerr<<"col index = "<<j<<" out of range [0,"<<ncols-1<<"]\n";
    exit(1);
  }
  return data[j+ncols*i];
}


