/*
 * Author: WWS
 * Purpose: simple dense matrix class, after struct mat
 */

#ifndef __CAAM420_MATDENSE__
#define __CAAM420_MATDENSE__

#include "matbase.hh"

class MatDense: public MatBase {

private:

  int nrows;
  int ncols;
  double * data;

  /* here is a way to make sure that the useless
     and irritating default constructor does not 
     get called

     The practical effect: any successfully constructed
     MatDense must have allocated memory to the double *
     data. Therefore it can safely be deleted in the 
     destructor.
  */
  MatDense();

public:

  /** the real constructor */
  MatDense(int n, int m);

  /** the real destructor */
  ~MatDense() { delete [] data; }

  /** abstract nrows, ncols functions */
  int getNumRows() const { return nrows; }
  int getNumCols() const { return ncols; }

  /** indexing op - non-const*/
  double & operator()(int i,int j);
  /** indexing op - const */
  virtual double const & operator()(int i,int j) const;

};

#endif
