/* 
 * Author: WWS
 * Purpose: subclass MatDense to add file i/o capability
 */

#ifndef __CAAM420_MATDENSEF__
#define __CAAM420_MATDENSEF__

#include "matdense.hh"

extern "C" {
#include "mio.h"
}

class MatFile: public MatDense {

  /* here is a way to make sure that the useless
     and irritating default constructor does not 
     get called
  */
  MatFile();

public:

  /** construct dense matrix by reading file */
  MatFile(int n, int m): MatDense(n,m) {}

  /** read matrix from minfo file pair */
  void MatFile::readMat(char const * fname);

  /** write the matrix out as an minfo file pair - 
      minfo file name = fname, data file name = dname 
      (note that the latter has to be non-const, not because
      it will be changed - it won't - but because it's being
      passed to a a non-const arg of minfo_write).
  */
  void writeMat(char const * fname, char * dname) const;

};

#endif

