/*
 * Author: WWS
 *
 * Purpose: driver code for my solution of HW 5
 */

#include "mat.h"

int matmult(struct mat, struct vec, struct vec);

int main(int argc, char ** argv) {

  FILE * fp;    /* input/output stream */
  struct mat m; /* matrix, to be read from argv[1] */
  struct vec x; /* vector, to be read from argv[2] */
  struct vec b; /* vector, to be written to argv[3] */

  if (argc !=4) {
    printf("multiplies mat a times vec x, stores result in vec b\n");
    printf("all stored in ascii files in natural format\n\n");
    printf("usage: (prog name) [a file] [x file] [b file]\n");
    exit(1);
  }

  /* open matrix file for read */
  if (!(fp=fopen(argv[1],"r"))) {
    fprintf(stderr,"Oops no mat file\n");
    exit(1);
  }

  /* construct matrix, initialize by reading from file */
  mat_construct(&m);
  if (mat_finit(&m,fp)) {
    fprintf(stderr,"Oops blew it in mat_finit\n");
    exit(1);
  }
  //  mat_print(m);
  
  /* close stream so that it can be re-used */
  fclose(fp);
  
  /* open vector file for read */
  if (!(fp=fopen(argv[2],"r"))) {
    fprintf(stderr,"Oops no input vec file\n");
    exit(1);
  }
  
  /* construct vector, initialize by reading from file */
  vec_construct(&x);
  if (vec_finit(&x,fp)) {
    fprintf(stderr,"Oops blew it in vec_finit\n");
    exit(1);
  }
  //  vec_print(x);
  
  /* close stream so that it can be re-used */   
  fclose(fp);

  /* construct output vector, initialize from row dim of matrix */
  vec_construct(&b);
  vec_init(&b,m.nrows);

  /* finally... matrix multipication! */
  if (matmult(m,x,b)) {
    fprintf(stderr,"Oops blew it in matmult\n");
    exit(1);
  }

  /* open file for vector output */
  if (!(fp=fopen(argv[3],"w"))) {
    fprintf(stderr,"Oops no output vec file\n");
    exit(1);
  } 

  /* write vector file */
  vec_fprint(b,fp);

  /* redundant - exit will take care of closing all files opened
     by program 
  */
  fclose(fp);

  /* normal exit */
  exit(0);
}
  
