/* 
 * Author: WWS
 *
 * Purpose: matrix multiply using matrix and vector structures
 * discussed in class notes. Part of HW 5 solution.
 */

#include "mat.h"

/* 
 * multiplies matrix in a times vector in x, stores output in b
 */
int matmult(struct mat a, struct vec x, struct vec b) {

  int i,j;  /* counters */

  /* sanity check */
  if ((a.nrows != b.len) || (a.ncols != x.len)) {
    printf("ERROR: matmult\n");
    printf("  incompatible data\n");
    printf("  matrix nrows=%d ncols=%d\n",a.nrows,a.ncols);
    printf("  input vec len=%d\n",x.len);
    printf("  output vec len=%d\n",b.len);
    return E_BOUNDS;
  }

  /* standard matrix multiply assuming column-major storage
   */
  for (i=0;i<a.nrows; i++) {
    b.vdata[i]=0.0;
    for (j=0;j<a.ncols;j++) 
      b.vdata[i]+=a.mdata[i+j*a.nrows]*x.vdata[j];
  }

  return 0;
}
