#include "mio.h"

int minfo_read(int * nrows, int * ncols, char * in, FILE * fp) {

  int i;
  int ok1=0;
  int ok2=0;
  int okin=0;
  char s[MAXC];

  *nrows=0;
  *ncols=0;
  for (i=0;i<MAXC;i++) in[i]='\0';
  while (fgets(s,MAXC,fp)) {
    //    printf("s=%s ok1=%d ok2=%d okin=%d\n",s,ok1,ok2,okin); 
    i=0;
    while ((ok1!=1) && i<MAXC-1) {
      ok1=sscanf(&(s[i]),"n1=%d",nrows);
      //      printf("nrows: %d %d %d %s\n",i,ok1,*nrows,&(s[i]));
      i++;
    }
    i=0;
    while ((ok2!=1) && i<MAXC-1) {
      ok2=sscanf(&(s[i]),"n2=%d",ncols);
      //      printf("ncols: %d %d %d %s\n",i,ok2,*ncols,&(s[i]));
      i++;
    }
    i=0;
    while ((okin!=1) && i<MAXC-1) {
      okin=sscanf(&(s[i]),"in=%s",in);
      //      printf("in: %d %d %s %s\n",i,okin,in,&(s[i]));
      i++;
    }
  }

  if (!(ok1*ok2*okin)) {
    fprintf(stderr,"Error: minfo_read\n");
    fprintf(stderr,"failed to read n1 or n2, or input filename\n");
    return 1;
  }

  if ((*nrows<1) ||
      (*ncols<1) ||
      (strlen(in)<1)) {
    fprintf(stderr,"Error: minfo_read\n");
    fprintf(stderr,"failed to assign legit vals to n1 or n2, or input filename\n");
    return 1;
  }

  return 0;
}

void minfo_write(int nrows, int ncols, char * in, FILE * fp) {
  fprintf(fp,"n1=%d\n",nrows);     
  fprintf(fp,"n2=%d\n",ncols);
  fprintf(fp,"in=%s\n",in);
}

// small test program
/*
int main() {

  int nrows=34;
  int ncols=48;
  char in[MAXC]="fruitcake";
  char out[MAXC];
  FILE * fp = fopen("test.minfo","w");
  minfo_write(nrows,ncols,in,fp);
  fclose(fp);
  fp=fopen("test.minfo","r");
  minfo_read(&nrows,&ncols,out,fp);
  printf("nrows=%d ncols=%d in=%s\n",nrows,ncols,out);
}
*/

