#ifndef __WWS_MIO__
#define __WWS_MIO__

#include "cstd.h"

#define MAXC 128

/*
 * reads matrix info in the form 
 *
 * - n1=[nrows] 
 *
 * - n2=[ncols] -
 * 
 * - in=[fname] 
 * 
 * The data filename in the char* fname should be a string
 * (null-terminated char array. It must be allocated in the calling
 * function.
 * 
 * The calling function must open the file to be read (NOTE - this is
 * NOT fname, which is intended to be the name of a file containing
 * matrix entries, but another file which contains the above
 * information only), and associated it with the FILE * argument fp,
 * via a call to fopen. The call to fopen must specify that the file
 * is readable (permission r or r+, or w+ if the calling function
 * subsequently writes the file and seeks to the start of file before
 * calling minfo). The file should be positioned at the beginning.
 */
int minfo_read(int* n1,int* n2,char* fname, FILE* fp);

/*
 * writes matrix info in same format as minfo_read reads it. Integer 
 * inputs n1 and n2 should be initialized to nrows and ncols respectively
 * and the string fname to the name of the data file which will contain
 * the matrix entries.
 */
void minfo_write(int n1,int n2,char* fname, FILE* fp);

#endif
