#ifndef __CAAM420_OPMAT__
#define __CAAM420_OPMAT__

#include "op.hh"
#include "matbase.hh"

class OpMat: public Op {

private:

  MatBase const & m;

  OpMat();

public:

  // 1. omit base class constructor, since it doesn't 
  // actually do anything
  // use member initialization to initialize the const reference
  // member - this is the only way to initialize references. 
  OpMat(MatBase const & _m): m(_m) {}

  // implemented, so not virtual - implementation simply
  // calls matmult method of MatBase member
  void matmult(VecPPBase const & vecin,
	       VecPPBase & vecout) const;

};

#endif
