#include "vecppfile.hh"

void VecPPFile::readVec(char const * fname) {

  FILE * fp=NULL;
  if (!(fp=fopen(fname,"r"))) {
    cerr<<"Error: VecPPFile::readVec\n";
    cerr<<"failed to open file "<<fname<<"\n";
    exit(1);
  }

  int n;
  int i;
  int ok1=0;
  int okin=0;
  char s[MAXC];
  char in[MAXC];

  for (i=0;i<MAXC;i++) in[i]='\0';

  while (fgets(s,MAXC,fp)) {
    //    printf("s=%s ok1=%d ok2=%d okin=%d\n",s,ok1,ok2,okin); 
    i=0;
    while ((ok1!=1) && i<MAXC-1) {
      ok1=sscanf(&(s[i]),"n1=%d",&n);
      //      printf("nrows: %d %d %d %s\n",i,ok1,*nrows,&(s[i]));
      i++;
    }
    i=0;
    while ((okin!=1) && i<MAXC-1) {
      okin=sscanf(&(s[i]),"in=%s",in);
      //      printf("in: %d %d %s %s\n",i,okin,in,&(s[i]));
      i++;
    }
  }

  if (!(ok1*okin)) {
    cerr<<"Error: VecPPFile::readVec\n";
    cerr<<"failed to read n1 or input filename\n";
    exit(1);
  }

  if (n!=this->getLength()) {
    cerr<<"Error: VecPPFile::readVec\n";
    cerr<<"read n1="<<n<<" != this->getLength()="<<this->getLength()<<"\n";
    exit(1);
  }

  ifstream from(in,ios::in);
  i=0;
  
  while (i<this->getLength() && from>>(*this)(i)) i++;
  if (i != this->getLength()) {
    cerr<<"Error: VecPPFile::readVec\n";
    cerr<<"failed to read "<<this->getLength()<<" doubles from file "<<in<<"\n";
    exit(1);
  }

}

void VecPPFile::writeVec(char const * fname, char const * dname) {

  ofstream ff(fname,ios::out);
  ff<<"n1="<<this->getLength()<<"\n";
  ff<<"in="<<dname<<"\n";
  ff.close();

  ofstream dd(dname,ios::out);
  for (int i=0;i<this->getLength();i++)
    dd<<(*this)(i)<<"\n";
  dd.close();
    
}

