#include "vecppgsl.hh"

VecPPGSL::VecPPGSL(int n) { gv = gsl_vector_alloc(n); }
/* logical copy constructor - produces an independent copy.
   note how const is used consistently throughout.
*/
VecPPGSL::VecPPGSL(VecPPGSL const & v) {
  gv=gsl_vector_alloc(v.getLength());
  gsl_vector_memcpy(gv,v.gv);
}
  
VecPPGSL::~VecPPGSL() { gsl_vector_free(gv); }

int VecPPGSL::getLength() const { return (int)(gv->size); }
double & VecPPGSL::operator()(int i) {  return gv->data[i]; }
double const & VecPPGSL::operator()(int i) const {  return (gv->data[i]); }
gsl_vector & VecPPGSL::getGSLVec() { return *gv; }
gsl_vector const & VecPPGSL::getGSLVec() const { return *gv; }
ostream & VecPPGSL::report(ostream & str) const {
  str<<"VecPPGSL object, length = "<<this->getLength()<<"\n";
  for (int i=0;i<this->getLength();i++) str<<"v["<<i<<"]="<<(*this)(i)<<"\n";
  return str;
}

void VecPPGSL::test() const {
  //gsl_vector * kk = &(this->getGSLVec());
  gsl_vector * kk = gv;
  gsl_vector k = this->getGSLVec();
  kk->data[0]=1.0;

  VecPPGSL vc(*this);
  gsl_vector * kptr = &(vc.getGSLVec());
  kptr->data[0]=2.0;
}

