/*
 * Author: WWS
 * Purpose: template for GSL-based Vector class
 */

#ifndef __CAAM420_VECGSL__
#define __CAAM420_VECGSL__

#include "vecppbase.hh"
extern "C" {
#include <gsl/gsl_vector.h>
}

class VecPPGSL: public VecPPBase {

private:

  // will USE a gsl_vector "object" (struct) to implement VecPPBase
  // functionality - a VecPPGSL "has a" gsl_vector, rather than
  // "is a" gsl_vector

  gsl_vector * gv;

  // disallow default allocation (with no dimn info)
  VecPPGSL();


public:

  // presumably the main constructor would look like that of VecPPDense,
  // since this class represents the same concept
  VecPPGSL(int _n);

  // logical copy constructor - produces independent copy
  VecPPGSL(VecPPGSL const &);

  // destructor
  ~VecPPGSL();

  // implement the pure virtual VecPPBase methods
  int getLength() const;
  double & operator()(int i);
  double const & operator()(int i) const;
  ostream & report(ostream & str) const;

  // special additional functions to allow other GSL functions to 
  // work with the gsl struct data member
  gsl_vector & getGSLVec();
  gsl_vector const & getGSLVec() const;

  void test() const;
};

#endif
